#!/usr/bin/perl

  require "apache-lib.pl";
  &ReadParse();

  ($conf, $v) = &get_virtual_config($in{'virt'});


  &header("Upload a Certificate/Key Pair", "");

  ($ssldir) = ($in{'file'} =~ m/^(.*)\/[^\/]*$/);

  $ServerName = &virtual_name($v);
  $ssldir     = "/home/httpd/$ServerName-443/ssl";
  $virt       = $in{'virt'};

  ### Pull our existing certificate/key into variables for printing later.
  if (-r "$ssldir/certificate.pem" && -r "$ssldir/key.pem") {
    $existing_cert = `cat $ssldir/certificate.pem`;
    $existing_key  = `cat $ssldir/key.pem`;

    $sslstatus = "<FONT COLOR=GREEN>Enabled</FONT>";

    $fingerprint_str = `openssl x509 -fingerprint -in $ssldir/certificate.pem`;
    ($cert_fingerprint) = ($fingerprint_str =~ m/Fingerprint\=(.*)/);

    $expiry_str  = `openssl x509 -dates -in $ssldir/certificate.pem`;
    ($cert_start) = ($expiry_str =~ m/notBefore\=(.*)/);
    ($cert_end)   = ($expiry_str =~ m/notAfter\=(.*)/);

    $issuer_str     = `openssl x509 -issuer -in $ssldir/certificate.pem`;
    ($issuer_o)     = ($issuer_str =~ m/\/O\=([^\/]+)\//);
    ($issuer_cn)    = ($issuer_str =~ m/\/CN\=([^\/]+)\//);
    ($issuer_email) = ($issuer_str =~ m/\/Email\=([^\-]+)/);

    $subject_str     = `openssl x509 -subject -in $ssldir/certificate.pem`;
    ($subject_o)     = ($subject_str =~ m/\/O\=([^\/]+)\//);
    ($subject_cn)    = ($subject_str =~ m/\/CN\=([^\/]+)\//);
    ($subject_email) = ($subject_str =~ m/\/Email\=([^\-]+)/);

  $CERTIFICATE_INFO  = "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=90%>";
  $CERTIFICATE_INFO .= "<TR>\n";
  $CERTIFICATE_INFO .= "  <TD><DIV CLASS=nbody><B>Fingerprint</B></TD>\n";
  $CERTIFICATE_INFO .= "  <TD><DIV CLASS=nbody>$cert_fingerprint\n";
  $CERTIFICATE_INFO .= "</TR>\n";

  $CERTIFICATE_INFO .= "<TR><TD COLSPAN=2>&nbsp;</TD></TR>\n";

  $CERTIFICATE_INFO .= "<TR>\n";
  $CERTIFICATE_INFO .= "  <TD><DIV CLASS=nbody><B>Valid</B></TD>\n";
  $CERTIFICATE_INFO .= "  <TD><DIV CLASS=nbody>$cert_start until $cert_end\n";
  $CERTIFICATE_INFO .= "</TR>\n";

  $CERTIFICATE_INFO .= "<TR><TD COLSPAN=2>&nbsp;</TD></TR>\n";

  $CERTIFICATE_INFO .= "<TR>\n";
  $CERTIFICATE_INFO .= "  <TD VALIGN=TOP><DIV CLASS=nbody><B>Subject</TD>\n";
  $CERTIFICATE_INFO .= "  <TD><DIV CLASS=nbody>$subject_cn\n";
  $CERTIFICATE_INFO .= "      <BR>$subject_o\n";
  $CERTIFICATE_INFO .= "      <BR>$subject_email\n";
  $CERTIFICATE_INFO .= "</TR>\n";

  $CERTIFICATE_INFO .= "<TR><TD COLSPAN=2>&nbsp;</TD></TR>\n";

  $CERTIFICATE_INFO .= "<TR>\n";
  $CERTIFICATE_INFO .= "  <TD VALIGN=TOP><DIV CLASS=nbody><B>Issuer</B></TD>\n";
  $CERTIFICATE_INFO .= "  <TD><DIV CLASS=nbody>$issuer_cn\n";
  $CERTIFICATE_INFO .= "      <BR>$issuer_o\n";
  $CERTIFICATE_INFO .= "      <BR>$issuer_email\n";
  $CERTIFICATE_INFO .= "</TR>\n";

  $CERTIFICATE_INFO .= "</TABLE>";


  }
  else { $sslstatus = "<FONT COLOR=RED>Disabled</FONT>"; }

  print <<EOF02;
  <FORM ACTION=do_cert_enter.cgi METHOD=POST ENCTYPE="multipart/form-data">
  <INPUT TYPE=HIDDEN NAME=certfile VALUE=\"$ssldir/certificate.pem\">
  <INPUT TYPE=HIDDEN NAME=keyfile VALUE=\"$ssldir/key.pem\">
  <INPUT TYPE=HIDDEN NAME=virt VALUE=\"$virt\">

  <P><CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>
  <TR $tb>
    <TD COLSPAN=2><DIV CLASS=ttitle>
      <B>Upload a New Certificate and Key</B>
    </DIV></TD>
  </TR>

  <TR $cb>
    <TD WIDTH=20>&nbsp;</TD>
    <TD $cb>
      <TABLE BORDER=0 WIDTH=100% CELLPADDING=0 CELLSPACING=0>

      <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Current SSL Status</B></DIV></TD>
        <TD><DIV CLASS=nbody><B>$sslstatus</B></DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

      <TR $cb>
        <TD VALIGN=TOP><DIV CLASS=nbody><B>Current SSL Certificate</B></DIV></TD>
        <TD><B>$CERTIFICATE_INFO</B></DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN=2>&nbsp;</TD> </TR>

      <TR $cb>
        <TD VALIGN=TOP><DIV CLASS=nbody><B>Upload SSL Certficiate</TD>
        <TD>
          <DIV CLASS=tbody><INPUT TYPE="file" NAME="certificate_up"></DIV>
          <DIV CLASS=nbody><INPUT TYPE=CHECKBOX NAME=nokey VALUE="$ssldir/key.pem"> <B>Use existing key</B>
        </TD>
      </TR>

      <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Upload SSL Key</TD>
        <TD><DIV CLASS=tbody><INPUT TYPE="file" NAME="key_up"></TD>
      </TR>

      <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

      <TR $cb><TD COLSPAN=2 ALIGN=RIGHT><DIV CLASS=nbody>
        <INPUT TYPE=SUBMIT NAME="upload" VALUE="Save">

      </TD></TR>
      </TABLE>
    </TD>
  </TR>
  </TABLE></CENTER></FORM><P>

EOF02

  &ryanFooter("/VHost/cert_index.cgi?virt=$virt");

