#!/usr/bin/perl

  require "apache-lib.pl";
  &ReadParse();

  ($conf, $v) = &get_virtual_config($in{'virt'});


  &header("Certificate Signing Request Generation", "");

  ($ssldir) = ($in{'file'} =~ m/^(.*)\/[^\/]*$/);

  $ServerName = &virtual_name($v);
  $ssldir     = "/home/httpd/$ServerName-443/ssl";
  $virt       = $in{'virt'};


  $authority_str    = &hlink("Authority Name", "ssl_authority");
  $email_str        = &hlink("E-Mail Address", "ssl_email");
  $department_str   = &hlink("Department", "ssl_department");
  $organization_str = &hlink("Organization", "ssl_organization");
  $city_str         = &hlink("City", "ssl_city");
  $state_str        = &hlink("State or Province", "ssl_state");
  $country_str      = &hlink("Country", "ssl_country");

print <<EOF01;
  <FORM ACTION="do_csr_gen.cgi" METHOD="post">
  <INPUT TYPE=HIDDEN NAME=ssldir VALUE=\"$ssldir\">
  <INPUT TYPE=HIDDEN NAME=virt VALUE=\"$virt\">
  <P><CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>
  <TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Certificate Generation</B></DIV></TD></TR>
  <TR $tb><TD COLSPAN=2><DIV CLASS=thead><B>For $ServerName</B></TD></TR>
  <TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
    This form is to create a new certificate signing request (CSR) for
    $ServerName.  A CSR is used to pass along to a certificate authority (CA)
    such as Verisign or Thawte to produce a signed certificate for this site.
    For more information on getting a certificate signed please refer to the
    documentation.

    <P>If you do not have an existing certificate/key pair, check the "Create
    New Certificate/Key Pair" box.  If you do have an existing certificate/key
    pair then the CSR will be generated using the existing key.  When you get
    the signed certificate back from the CA you can simply drop it into place
    for use with the existing key.

    <P><B>Please note</B> that by checking the "Create New Certificate/Key
    Pair" box, you will overwrite the existing certificate/key pair, if any.
  </TD></TR>
  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $cb>
    <TD WIDTH=20>&nbsp;</TD>
    <TD><TABLE BORDER=0 WIDTH=100% CELLPADDING=0 CELLSPACING=0>
  
    <TR $tb><TD COLSPAN=2>
      <DIV CLASS=thead><B>Create New Certificate and Key</B></DIV>
    </TD></TR>

    <TR $cb><TD COLSPAN=2>
      <DIV CLASS=nbody>
        <INPUT TYPE="CHECKBOX" NAME="new"> <B>Create New Certificate/Key Pair
      </DIV>
    </TD></TR>

    <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

    <TR $tb><TD COLSPAN=2>
      <DIV CLASS=thead><B>Certificate Signing Request</B></DIV>
    </TD></TR>

    <TR $cb>
      <td><DIV CLASS=nbody><b>$authority_str</b></td>
      <td><INPUT NAME=commonName SIZE=30 MAXLENGTH=64 VALUE="$ServerName"></td>
    </TR>

    <TR $cb>
      <td><DIV CLASS=nbody><b>$email_str</b></td>
      <td><INPUT NAME=emailAddress SIZE=30 MAXLENGTH=40></td>
    </TR>

    <TR $cb>
      <td><DIV CLASS=nbody><b>$organization_str</b></td>
      <td><INPUT NAME=organizationName SIZE=30></td>
    </TR>

    <TR $cb>
      <td><DIV CLASS=nbody><b>$department_str</b></td>
      <td><INPUT NAME=organizationalUnitName SIZE=30></td>
    </TR>

    <TR $cb>
      <td><DIV CLASS=nbody><b>$city_str</b></td>
      <td><INPUT NAME=localityName SIZE=30></td>
    </TR>

    <TR $cb>
      <td><DIV CLASS=nbody><b>$state_str</b></td>
      <td><INPUT NAME=stateOrProvinceName SIZE=15></td>
    </TR>

    <TR $cb>
      <td><DIV CLASS=nbody><b>$country_str</b></td>
      <td><INPUT NAME=countryName SIZE=3 MAXLENGTH=2></td>
    </TR>


    </TABLE></TD>
  </TR>

  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $cb>
    <TD COLSPAN=2 ALIGN=RIGHT><DIV CLASS=nbody>
      <INPUT TYPE=SUBMIT VALUE="Generate CSR">
    </TD>
  </TR>
  </TABLE></CENTER><P>
EOF01

  &ryanFooter("/VHost/cert_index.cgi?virt=$virt");

