#!/usr/bin/perl

  require './apache-lib.pl';

  ### Check for the httpd.conf file.
  if ($config{'httpd_conf'}) { $htconf = $config{'httpd_conf'}; }
  else { $htconf = "$conf/httpd.conf"; }

  if (!-r $htconf) {
    ### Still doesn't exist!
    &header("Virtual Host Management", "");

    print "<CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>\n";
    print "<TR><TD>\n";
    print &text('index_econf', "<tt>$htconf</tt>",
          "/config.cgi?$module_name"),"<p>\n";

    print "</TD></TR>\n";
    print "</TABLE></CENTER>\n\n";

    &ryanFooter("/");
    exit;
  }


  ### Extract the configuration file into $conf.
  $conf = &get_config();

  ### ####################################### ###
  ### Print the header and let the fun begin. ###
  ### ####################################### ###
  &header("Virtual Host Management", "");

  my @foo = (
    foo('Create a New Store',  'CorpCommerce_verify.jpg'),
    foo('Edit/Delete a Store', 0),
    foo('Configure a Store',   'CorpCommerce_mainconfig.jpg'),
  );
  my @bar = (
    'Create a new osCommerce store.',
    foo('Edit or delete an existing osCommerce store.', 0),
    'Create products, variances, and other store items',
  );

  ### Add all of the servers.
  @virt = &find_directive_struct("VirtualHost", $conf);

print <<EOF01;
<P><CENTER><TABLE WIDTH=620 BORDER=0 CELLPADDING=0 CELLSPACING=0>
  <TR $tb><TD COLSPAN=3><DIV CLASS=ttitle><B>Virtual Servers</TD></TR>

  <TR $cb>
    <TD COLSPAN=3><DIV CLASS=nbody>
      Below is a listing of the virtual servers you currently have on your
      system.
   </DIV></TD>
  </TR>

  <TR $cb><TD COLSPAN=3>&nbsp;</TD></TR>

  <TR $tb>
    <TD><DIV CLASS="thead"><b>$text{'index_port'}</b></TD>
    <TD><DIV CLASS="thead"><b>$text{'index_name'}</b></TD>
    <TD><DIV CLASS="thead"><b>$text{'index_root'}</b></TD>
  </TR>

EOF01


  my ($VIRT_COUNT); $VIRT_COUNT = 0;

  foreach $v (@virt) {
    $VIRT_COUNT++;

    $INDEX = &indexof($v, @$conf);
    $vconf = &get_config()->[$INDEX];

    ### Extract DocumentRoot directive.
    $tmp = &find_directive_struct("DocumentRoot", $vconf->{'members'});
    $ROOT = $tmp->{'words'}->[0];

    ### Extract ServerName directive.
    $tmp = &find_directive_struct("ServerName", $vconf->{'members'});
    $NAME = $tmp->{'words'}->[0];

    ### Extract DocumentRoot directive.
    $tmp = &find_directive_struct("DocumentRoot", $vconf->{'members'});
    $DROOT = $tmp->{'words'}->[0];

    ### Extract Port directive.
    if ($v->{'value'} =~ /^(\S+):(\S+)$/) { $PORT = $2; }
    else { $PORT = &def(&find_directive("Port", $conf), 80); }

    if ((! -e "$DROOT/conf/site.pm") && ($INDEX != "-1")){
      print "  <TR $cb>\n";
      print "    <TD><DIV CLASS=nbody>$PORT</TD>\n";
      print "    <TD><DIV CLASS=nbody>\n";
      print "      <A HREF=\"virt_index.cgi?virt=$INDEX\">$NAME</A>\n";
      print "    </TD>\n";
      print "    <TD WIDTH=60%><DIV CLASS=nbody>$DROOT</TD>\n";
      print "  </TR>\n";
    }

  }

  ###  If there are no virtual servers defined, tell them.
  if (! $VIRT_COUNT) {
    print <<EOF;
  <TR $cb>
    <TD COLSPAN="3"><DIV CLASS="nbody"><B>
      There are currently no virtual servers defined.
    </B></DIV></TD>
  </TR>
EOF
  }

  print "  <TR $cb><TD COLSPAN=3>&nbsp;</TD></TR>\n";
  print "</TABLE></CENTER>\n";

print <<EOF;
<P><CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>
  <TR $tb>
    <TD COLSPAN=2><DIV CLASS=ttitle><B>
      Virtual Host Management
    </TD>
  </TR>

  <TR $cb>
    <TD COLSPAN=2><DIV CLASS=nbody>
      Below you can configure your virtual hosts.
    </TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD VALIGN=TOP><DIV CLASS="nbody"><B>
      <A HREF="vhost_create.cgi">Create a Virtual Host</A></B></DIV>
    </TD>
    <TD><DIV CLASS=nbody>Setup a new virtual host.</TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD VALIGN=TOP><DIV CLASS="nbody"><B>
      <A HREF="vhost_create_ssl.cgi">Create an SSL Virtual Host</A></B></DIV>
    </TD>
    <TD><DIV CLASS=nbody>Setup a new SSL-based virtual host.</TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>
  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD VALIGN=TOP><DIV CLASS="nbody"><B>
      <A HREF="nv_hosts.cgi">Setup Name Virtual Hosts</A></B></DIV>
    </TD>
    <TD><DIV CLASS=nbody>
      Configure which IP addresses you would like to run virtual hosts from.
    </TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD VALIGN=TOP><DIV CLASS="nbody"><B>
      <A HREF="webalizer/">Configure Website Log Analysis</A></B></DIV>
    </TD>
    <TD><DIV CLASS=nbody>
      Configure various options for generating web statistics.
    </TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>
  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD COLSPAN=2><DIV CLASS=nbody>
      <FORM ACTION=restart.cgi>
      <INPUT TYPE=SUBMIT VALUE="Restart Web Server">
      Click here to restart the web server so your changes take effect.
      <P></FORM>
    </TD>
  </TR>


  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

</TABLE></CENTER><P>

<P><CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>
  <TR $tb>
    <TD COLSPAN=2><DIV CLASS=ttitle><B>
      osCommerce Management
    </TD>
  </TR>

  <TR $cb>
    <TD COLSPAN=2><DIV CLASS=nbody>
      Below you can configure your stores.
    </TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD VALIGN=TOP><DIV CLASS="nbody">
      <B>$foo[0]</B>
    </TD>
    <TD><DIV CLASS=nbody>$bar[0]</DIV></TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD VALIGN=TOP><DIV CLASS="nbody"><B>
      <B>$foo[1]</B>
    </TD>
    <TD><DIV CLASS=nbody>$bar[1]</DIV></TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

  <TR $cb>
    <TD VALIGN=TOP><DIV CLASS="nbody"><B>
      <B>$foo[2]</B>
    </TD>
    <TD><DIV CLASS=nbody>$bar[2]</DIV></TD>
  </TR>

  <TR $cb><TD COLSPAN=2> &nbsp; </TD></TR>

</TABLE></CENTER><P>
EOF

  &ryanFooter("/");

################################################################################
sub foo($$) {
  my $msg          = shift;
  my $img          = shift;
  my $width        = 820;
  my $height       = 700;
  my ($eval_color) = ($tb =~ m/^bgcolor\=([^\"]+)$/);
  my $rv           = '';

  if ($img) {
    $rv  = "<A onClick=\"window.open('oscommerce-eval/show_screenshot.cgi?file=$img', 'foo', "
         . "'toolbar=no,menubar=no,scrollbars=yes,resize=yes,width=$width,"
         . "height=$height');\" HREF=\"#\">";
  }

  $rv .= "<FONT COLOR=\"$eval_color\">$msg</FONT>";

  if ($img) { $rv .= "</A>"; }

  return $rv;
}
