#!/usr/bin/perl

  require './apache-lib.pl';

  ### Make sure our httpd.conf is valid before we restart the daemon.
  $out = `/usr/sbin/httpd -t 2>&1`;


  ### Syntax is okay, so let's restart the daemon.
  if ($out =~ m/Syntax OK$/) {

    ###
    ### Before we restart apache, let's reload the LIDS config.
    ### (See if there are new certs/keys to be protected.
    ###
    &lids_toggle("off");
    &lids_reload();
    &lids_toggle("on");


    ### Clean and save the environment.
    my %ENV_RESTORE;
    %ENV_RESTORE  =  &clean_env();

      ### Restart the daemon.
      $out1 = `/etc/init.d/httpd restart 2>&1`;

    ### Restore the environment.
    &restore_env(%ENV_RESTORE);


    ### Restart did not work, complain.
    if ($out1 =~ m/Starting.*FAILED/) {
      &PrintError("Apache did not restart successfully.");
      exit;
    }

    ### Have a cigarette.
    sleep 1;

    ### Go home.
    &redirect("");
  }

  ### There is a syntax error so let's print it out.
  else {

    ### Good ol' header.
    &header("Error in apache configuration", "");

    print <<EOF01;
<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=620>
<TR $tb><TD COLSPAN=2>
  <DIV CLASS=ttitle><B>Error in Apache Configuration</B></DIV>
</TD></TR>

<TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD WIDTH=20>&nbsp;</TD>
  <TD>
    <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=100%>
      <TR $tb><TD>
        <DIV CLASS=thead><B>
          The following error occured while trying to restart apache:
        </B></DIV>
      </TD></TR>

      <TR $cb><TD>&nbsp;</TD></TR>
      <TR $cb><TD><DIV CLASS=nbody>
        <PRE>$out</PRE>
      </DIV></TD></TR>
    </TABLE>
  </TD>
</TR>

<TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb><TD COLSPAN=2><DIV CLASS=nbody><B>
  Please go back into the module and fix these errors.
</B></DIV></TD></TR>

<TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
</TABLE></CENTER><P>

EOF01

     &ryanFooter("/VHost");
  }
