#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001, Guardian Digital Inc.
 | $Id: index.cgi,v 1.1.1.2 2001/12/11 06:50:41 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines.
  require '../apache-lib.pl';


  ###  Setup local variables.
  my (@conf_files, $COUNT);

  ###  Define local variables.
  chdir        "/etc/webalizer";
  @conf_files  =  glob "*.conf";
  $COUNT       =  0;


  ###  Print the standard header
  &header("Virtual Host Management :: Configure Website Log Analysis", "");

  ###  Print our HTML.
  print <<EOF;
<P><CENTER>
<TABLE WIDTH="620" BORDER="0" CELLPADDING="0" CELLSPACING="0">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS=ttitle><B>Configure Website Log Analysis</TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS=nbody>
      Below is a listing of the virtual servers you currently have on your
      system.  Please note that his list only includes normal web servers, and
      not SSL web servers.
    </TD>
  </TR>

  <TR $cb><TD COLSPAN="2">&nbsp;</TD></TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" CELLSPACING="0">
      <TR $tb>
        <TD><DIV CLASS="thead"><B>Site</B></TD>
        <TD><DIV CLASS="thead"><B>Configuration File</B></TD>
      </TR>
EOF


  ### Iterate through each server and print our info.
  foreach my $file (@conf_files)
  {
    next if ($file eq "webalizer.conf");

    my ($site, $filename);
    ($site)   = ($file =~m/^(.*)\.conf$/);
    $filename = "/etc/webalizer/$file";
    $COUNT++;

    print <<EOF;
      <TR $cb>
        <TD><DIV CLASS="nbody">$site</TD>
        <TD><DIV CLASS="nbody"><A HREF="edit_config.cgi?conf_file=$filename">$file</A></TD>
      </TR>

EOF
  }


  ###  No configs.  Tell them.
  if (! $COUNT) {
    print <<EOF;
      <TR $cb>
        <TD COLSPAN="2"><DIV CLASS="nbody"><B>
          There are no sites currently defined.
        </B></TD>
      </TR>
EOF
  }


  ###  More HTML.
  print <<EOF;
      </TABLE>
    </TD>
  </TR>

  <TR $cb><TD COLSPAN="2">&nbsp;</TD></TR>
</TABLE><P>
EOF

  ### I'm on my way... home... sweet... home...
  &ryanFooter("/VHost/index.cgi");

