#!/usr/bin/perl

  require '../apache-lib.pl';
  require '../../guardiandigital-lib.pl';
  &ReadParse();

  $filename = $in{'filename'};

  if (!-e $filename) { &PrintError("$filename does not exist."); }

  ($sitename) = ($filename =~ m/^.*\/(.*)\.conf$/);

  ### Read the original file into our hash.
  open FILE, $filename;
    while (<FILE>) {
      chomp $_;
      if ($_ !~ m/^(#|$)/) {
        ($key, $value) = split /\s+/, $_;
        $conf_file{$key} = $value;
      }
    }
  close FILE;

  ### Save a backup copy.
  # system "cp -a $filename $filename.webtoolsave > /dev/null 2>&1";

  ### Extract the ones that we want and replace value in hash.
  $conf_file{'HostName'}  = $in{'HostName'};
  $conf_file{'LogFile'}   = $in{'LogFile'};
  $conf_file{'OutputDir'} = $in{'OutputDir'};


  open CONFIG, ">$filename";
    @conf_keys = keys %conf_file;
    foreach (@conf_keys) { print CONFIG "$_ $conf_file{$_}\n"; }

    print CONFIG "DNSCache $in{'OutputDir'}/dns_cache.db\n";
    print CONFIG "DNSChildren 2\n";
  close CONFIG;


  ### Remove any exsisting cron entries.
  $tmp1 = "/etc/cron.daily/webalizer_" . $in{'HostName'};
  $tmp2 = "/etc/cron.weekly/webalizer_" . $in{'HostName'};
  unlink $tmp1;
  unlink $tmp2;


  if ($in{'cron'}) { $cron = $in{'cron'}; }
  else            { $cron = "daily"; }

  ### Take care of the new cron entry.
  $cron_file = "/etc/cron." . $cron . "/webalizer_" . $in{'HostName'};
  open CRON, ">$cron_file";
    print CRON "#!/bin/sh\n\n";
    print CRON "/usr/bin/webalizer -c $filename > /dev/null 2>&1\n";
    print CRON "/bin/chmod 644 $in{'OutputDir'}/* > /dev/null 2>&1\n";
  close CRON;

  chmod 0700, $cron_file;

  &redirect("edit_config.cgi?conf_file=$filename");

